commit d7d1d41119ab3951452af606850d54d3558e05f1
Author: freddy77 <freddy77>
Date:   Fri Aug 21 10:01:52 2009 +0000

    make ssl more threadsafe using pthread in libgcrypt if possible

diff --git a/ChangeLog b/ChangeLog
index b0fcae9..008665a 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Fri Aug 21 12:01:24 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/tds/net.c:
+	- make ssl more threadsafe using pthread in libgcrypt if possible
+
 Fri Aug 21 11:59:39 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/net.c:
 	- fix a problem with Interix (cfr
@@ -1778,4 +1782,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2855 2009/08/21 10:00:07 freddy77 Exp $
+$Id: ChangeLog,v 1.2856 2009/08/21 10:01:52 freddy77 Exp $
diff --git a/src/tds/net.c b/src/tds/net.c
index 777dbf3..394ac99 100644
--- a/src/tds/net.c
+++ b/src/tds/net.c
@@ -94,6 +94,10 @@
 #include <assert.h>
 
 #ifdef HAVE_GNUTLS
+#if defined(_THREAD_SAFE) && defined(TDS_HAVE_PTHREAD_MUTEX)
+#include "tdsthread.h"
+#include <gcrypt.h>
+#endif
 #include <gnutls/gnutls.h>
 #elif defined(HAVE_OPENSSL)
 #include <openssl/ssl.h>
@@ -103,7 +107,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: net.c,v 1.93 2009/08/21 10:00:07 freddy77 Exp $");
+TDS_RCSID(var, "$Id: net.c,v 1.94 2009/08/21 10:01:52 freddy77 Exp $");
 
 #undef USE_POLL
 #if defined(HAVE_POLL_H) && defined(HAVE_POLL) && !defined(C_INTERIX)
@@ -1355,6 +1359,13 @@ tds_tls_deinit(void)
 }
 #endif
 
+#if defined(_THREAD_SAFE) && defined(TDS_HAVE_PTHREAD_MUTEX)
+GCRY_THREAD_OPTION_PTHREAD_IMPL;
+#define tds_gcry_init() gcry_control(GCRYCTL_SET_THREAD_CBS, &gcry_threads_pthread)
+#else
+#define tds_gcry_init() do {} while(0)
+#endif
+
 int
 tds_ssl_init(TDSSOCKET *tds)
 {
@@ -1388,8 +1399,10 @@ tds_ssl_init(TDSSOCKET *tds)
 
 	/* FIXME place somewhere else, deinit at end */
 	ret = 0;
-	if (!tls_initialized)
+	if (!tls_initialized) {
+		tds_gcry_init();
 		ret = gnutls_global_init();
+	}
 	if (ret == 0) {
 		tls_initialized = 1;
 

